﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@


'#####################################################################################
'
'                        PROPER Name Capitalization Class
'
'                            Stevel05 9 March 2014
'                  V 1.1 - Added Roman Numerals - 23/01/2016
'
'#####################################################################################
'Class module
Sub Class_Globals
	Private Delimeters,Exclude As List
	Private RomanRegexALL As String = "(^[ivxlcdm]*(?:th$|rd$ |\b))*" '"([ivxlcdm]*(?:th|rd|\b))*"
	Private RomanRegexNUM As String = "[ivxlcdm]*"
	Private replaceAnd As Boolean
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(exclParticles As Boolean, excludeArticles As Boolean, excludeUnitsOfMeasure As Boolean, replaceAndArg As Boolean, exclDelimiters As Boolean)
	Delimeters.Initialize
	Exclude.Initialize
	'Always capitalize after one of these
	Delimeters.AddAll(Array As String("Mc","-"))

	If exclParticles = False Then Exclude.AddAll(Array As String("van","von","de"))
	If excludeArticles = False Then Exclude.AddAll(Array As String("and", "or", "the", "an", "a", "of", "in", "as"))
	If excludeUnitsOfMeasure = False Then addUnitsOfMeasure
	replaceAnd = replaceAndArg
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub setExclusions(exclParticles As Boolean, excludeArticles As Boolean, excludeUnitsOfMeasure As Boolean, replaceAndArg As Boolean, exclDelimiters As Boolean)
	'Always capitalize after one of these
	Delimeters.AddAll(Array As String("Mc","-"))

	Exclude.Clear
	If exclParticles = False Then Exclude.AddAll(Array As String("van","von","de"))
	If excludeArticles = False Then Exclude.AddAll(Array As String("and", "or", "the", "an", "a", "of", "in", "as"))
	If excludeUnitsOfMeasure = False Then addUnitsOfMeasure
	replaceAnd = replaceAndArg
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub clearExclusions
	'Always capitalize after one of these
	Delimeters.Clear
	Delimeters.AddAll(Array As String(""))
	Exclude.Clear

	replaceAnd = False
End Sub

Sub NameToProperCase(Name As String) As String
	Dim Pos As Int
	Dim Result As String

	'Set the whole string to lowercase
	Name = Name.ToLowerCase
	'Make sure there is no more than one space between words.
	Do While Name.Contains("  ")
		Name = Name.Replace("  "," ")
	Loop
	'Process
	'Break the name into words
	Dim Words() As String = Regex.Split(" ",Name)
	For i = 0 To Words.Length - 1
		Dim Word As String = Words(i)
		
		'Ignore excluded words
		If Exclude.IndexOf(Word) > -1 Then 
			Continue
		End If
		
		For Each Delim As String In Delimeters
			'Check for Roman Numerals
			Dim M As Matcher
			M = Regex.Matcher2(RomanRegexALL,Regex.CASE_INSENSITIVE,Word)
			

			If M.Find And M.Match <> "" Then
				'Capitalize just the Numerals
				M = Regex.Matcher2(RomanRegexNUM,Regex.CASE_INSENSITIVE,Word)

				If M.Find And M.Match <> "" Then
					Dim W As String = M.Match.ToUpperCase
					'Add the suffix
					W = W & Word.SubString(W.Length).ToLowerCase
					Word = W
					Pos = Word.IndexOf(Delim)
					If Pos > -1 Then
						If Word.Length > Pos + Delim.Length Then
							Word = Word.SubString2(0,Pos + Delim.Length) & Word.SubString2(Pos + Delim.Length,Pos + Delim.Length + 1).ToUpperCase & Word.SubString(Pos + Delim.Length + 1).ToLowerCase
						End If
					End If
				End If
			Else
				'Capitalize the first letter of each word
				If Word.Length = 1 Then
					Word = Word.ToUpperCase
				Else
					'If the word is longer than 1 character, capitalize after each delimiter it contains
					Word = Word.SubString2(0,1).ToUpperCase & Word.SubString(1)
					Pos = Word.IndexOf(Delim)
					If Pos > -1 Then
						If Word.Length > Pos + Delim.Length Then
							Word = Word.SubString2(0,Pos + Delim.Length) & Word.SubString2(Pos + Delim.Length,Pos + Delim.Length + 1).ToUpperCase & Word.SubString(Pos + Delim.Length + 1).ToLowerCase
						End If
					End If
				End If
			End If
		Next
		If replaceAnd And Word.ToLowercase.CompareTo("and")  = 0 Then
			Words(i) = "&"
		End If
		Words(i) = Word
	Next
	For i = 0 To Words.Length - 1
		Result = Result & Words(i)
		If i < Words.Length - 1 Then Result = Result & " "
	Next
	Return Result
End Sub

private Sub addUnitsOfMeasure
	Exclude.AddAll(Array As String( _
	"nm", _
	"um", _ 
	"mm", _ 
	"cm", _ 
	"m", _ 
	"km", _ 
	"ng", _ 
	"ug", _ 
	"mg", _ 
	"g", _ 
	"kg", _ 
	"T", _ 
	"kT", _ 
	"MT", _ 
	"GT", _ 
	"lm", _ 
	"lx", _ 
	"nN", _ 
	"uN", _ 
	"mN", _ 
	"N", _ 
	"kN", _ 
	"MN", _ 
	"GN", _ 
	"ps", _ 
	"ns", _ 
	"us", _ 
	"ms", _ 
	"s", _ 
	"ks", _ 
	"pA", _ 
	"nA", _ 
	"uA", _ 
	"mA", _ 
	"A", _ 
	"kA", _ 
	"MA", _ 
	"K", _ 
	"degC", _ 
	"degF", _ 
	"nF", _ 
	"pF", _ 
	"uF", _ 
	"mF", _ 
	"F", _ 
	"nH", _ 
	"uH", _ 
	"mH", _ 
	"H", _ 
	"uHz", _ 
	"mHz", _ 
	"Hz", _ 
	"kHz", _ 
	"MHz", _ 
	"GHz", _ 
	"THz", _ 
	"pJ", _ 
	"uJ", _ 
	"mJ", _ 
	"kJ", _ 
	"MJ", _ 
	"uOhm", _ 
	"mOhm", _ 
	"Ohm", _ 
	"kOhm", _ 
	"MOhm", _ 
	"GOhm", _ 
	"pV", _ 
	"nV", _ 
	"uV", _ 
	"mV", _ 
	"V", _ 
	"kV", _ 
	"MV", _ 
	"pPa", _ 
	"nPa", _ 
	"uPa", _ 
	"mPa", _ 
	"Pa", _ 
	"kPa", _ 
	"Mpa", _ 
	"GPa", _ 
	"deg", _ 
	"rad", _ 
	"mRad", _ 
	"pT", _ 
	"nT", _ 
	"uT", _ 
	"mT", _ 
	"T", _ 
	"kT", _ 
	"pW", _ 
	"nW", _ 
	"uW", _ 
	"mW", _ 
	"W", _ 
	"kW", _ 
	"MW", _ 
	"GW", _ 
	"TW", _ 
	"pWb", _ 
	"nWb", _ 
	"uWb", _ 
	"mWb", _ 
	"Wb", _ 
	"kWb", _ 
	"mWb", _ 
	"m/s", _ 
	"km/s", _ 
	"m/s^2", _ 
	"km/s^2"))
End Sub