﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
'Custom View class 
#Event: ExampleEvent (Value As Int)
#DesignerProperty: Key: tfeToolbarHeightKey, 			DisplayName: TFE Toolbar Hight, 			FieldType: Int, 		DefaultValue: 20, 		Description: Height of edit field toolbar.
#DesignerProperty: Key: tfeToolbarWidthKey,  			DisplayName: TFE Toolbar Width, 			FieldType: Int, 		DefaultValue: 150, 		Description: Width of edit field toolbar.
#DesignerProperty: Key: tfeToolbarBtnWidthKey,  		DisplayName: TFE Toolbar Button Width, 		FieldType: Int, 		DefaultValue: 20, 		Description: Width of edit field toolbar buttons.

#DesignerProperty: Key: tfeHintTextKey,  				DisplayName: Hint Text, 					FieldType: String, 		DefaultValue: Hint, 		Description: Hint Text.
#DesignerProperty: Key: tfeHintTextFcsdColorKey,  		DisplayName: Hint Focussed Color, 			FieldType: Color, 		DefaultValue: 0xFF708F69, 	Description: Focussed Hint Color.
#DesignerProperty: Key: tfeHintTextNonFcsdColorKey,  	DisplayName: Hint Non Focussed Color, 		FieldType: Color, 		DefaultValue: 0xFFA1C49A, 	Description: Non Focussed Hint Color
#DesignerProperty: Key: tfeHintTextFcsdFontSizeKey,  	DisplayName: Hint Focussed Font Size, 		FieldType: Int, 		DefaultValue: 10, 			Description: Focussed Font Size.
#DesignerProperty: Key: tfeHintTextNonFcsdFontSizeKey,  DisplayName: Hint Non Focussed Font Size, 	FieldType: Int, 		DefaultValue: 14, 			Description: Non Focussed Font Size.

#DesignerProperty: Key: tfeTextFontSizeKey,  			DisplayName: Text Font Size, 				FieldType: Int, 		DefaultValue: 14, 			Description: Text field font size
#DesignerProperty: Key: tfeTextFontColorKey,  			DisplayName: Text Font Color, 				FieldType: Color, 		DefaultValue: 0xFF000000, 	Description: Text field font color
#DesignerProperty: Key: tfeTextFontStyleKey,  			DisplayName: Text Style, 					FieldType: String, 		DefaultValue: NORMAL, 		List: NORMAL|BOLD|ITALIC|BOLD_ITALIC

#DesignerProperty: Key: KeyboardType, DisplayName: Keyboard Type, FieldType: String, List: Text|Numbers|Decimal, DefaultValue: Text

'--------------------------------------------------------------------------------------------------------------------
Sub Class_Globals
#IgnoreWarnings: 9
	Private mEventName 					As String 'ignore
	Private mCallBack 					As Object 'ignore
	Private mBase 						As Panel
	Private xui 						As XUI 'ignore
	Private Const DefaultColorConstant 	As Int = -984833 'ignore
	
	Private textStringInitial 	As String
	Private origProperStr 		As String
	Private properCycleInit 	As Boolean
	Private capsState 			As Int		'0 = as entered, 1 = Lower, 2 = Proper, 3 Upper, 4 Camel
		
	Private btnPanel 	As B4XView
	Private imgClear 	As B4XView
	Private imgProper 	As B4XView
	Private imgUndo 	As B4XView
	Private imgRedo 	As B4XView
	
	Private btnPanel As B4XView

	Private tfe As B4XFloatTextField
	Private tfePanel 				As B4XView
	Private tfeToolbarBtnWidth 		As Int
'	Private captureTextChange 		As Boolean
	Private toolBarBtnClearEvent 	As Boolean
	Private toolBarBtnUndoEvent 	As Boolean
	Private toolBarBtnRedoEvent 	As Boolean
	Private toolBarBtnProperEvent 	As Boolean
	
	Public Tag 					As Object
	
'	Private LastBaseHeight 		As Int
	Private LayoutLoaded 		As Boolean

	Private undoList 			As List
	Private undoListIndex 		As Int
	Private undoListIndexLast 	As Int
	Private SleepBeforeSearch 	As Int = 300
End Sub


'--------------------------------------------------------------------------------------------------------------------
Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	undoList.Initialize
	clearProperVars

	capsState = 1
	textStringInitial = ""

	#if B4J
	TextFlow.Initialize
	#Else If B4i
	FeedbackGenerator = FeedbackGenerator.Initialize("UIImpactFeedbackGenerator").RunMethod("alloc", Null).RunMethod("initWithStyle:", Array(0)) 'light
	#End If	
End Sub


'--------------------------------------------------------------------------------------------------------------------
#IgnoreWarnings: 12 
Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)
	mBase = Base
'	LastBaseHeight = mBase.Height
	Tag = mBase.Tag : mBase.Tag = Me
	LayoutLoaded = False
	tfe.Tag = "tfe"
	
	Sleep(10)
	
	mBase.LoadLayout("tfeCVLayout.bal")

	LayoutLoaded = True

	'Get parameters and set objects
	
	' Mini toolbar for tfe B4XFloatTextField
	' ********  All of these get updated on the screen  *********
	btnPanel.Height 	= IntToDIP(Props.GetDefault("tfeToolbarHeightKey", 15dip))
	btnPanel.Width 		= IntToDIP(Props.GetDefault("tfeToolbarWidthKey", 150dip))
	tfeToolbarBtnWidth 	= IntToDIP(Props.GetDefault("tfeToolbarBtnWidthKey", 15dip))
	
	imgClear.Width 		= tfeToolbarBtnWidth
	imgUndo.Width		= tfeToolbarBtnWidth
	imgProper.Width 	= tfeToolbarBtnWidth
	imgRedo.Width		= tfeToolbarBtnWidth
	
	imgClear.Height 	= btnPanel.Height
	imgUndo.Height		= btnPanel.Height
	imgProper.Height 	= btnPanel.Height
	imgRedo.Height		= btnPanel.Height
	' *************************************************************
	
	
	' B4XFloatTextField set parameters
	' ********  None OF the following update the screen  *********
	tfe.HintText 			= Props.GetDefault("tfeHintTextKey", "Hint")
	tfe.HintColor			= Props.GetDefault("tfeHintTextFcsdColorKey", 0xFF708F69)
	tfe.NonFocusedHintColor = Props.GetDefault("tfeHintTextNonFcsdColorKey", 0xFFA1C49A)
	tfe.LargeLabelTextSize =  Props.GetDefault("tfeHintTextFcsdFontSizeKey", 10)
	tfe.SmallLabelTextSize =  Props.GetDefault("tfeHintTextNonFcsdFontSizeKey", 14)
	tfe.HintLabelSmallOffsetY = -1dip
	
	tfe.TextField.TextColor	= Props.GetDefault("tfeTextFontColorKey", 0xFF000000)

	setTextFontSizeAndStyle(Props.GetDefault("tfeTextFontStyleKey", "NORMAL"), _
							Props.GetDefault("tfeTextFontSizeKey", 14))
	' *************************************************************
						
	mBase.Invalidate
End Sub


'--------------------------------------------------------------------------------------------------------------------
Sub IntToDIP(Integer As Int) As Int
	Dim r As Reflector
	Dim scale As Float
	r.Target = r.GetContext
	r.Target = r.RunMethod("getResources")
	r.Target = r.RunMethod("getDisplayMetrics")
	scale = r.GetField("density")
  
	Dim DIP As Int
	DIP = Integer * scale + 0.5
	Return DIP
End Sub

'--------------------------------------------------------------------------------------------------------------------
Public Sub setHintText(strArg As String)
	tfe.HintText = strArg
End Sub


'--------------------------------------------------------------------------------------------------------------------
Public Sub setHintLargeFont(sizeArg As Int)
	tfe.LargeLabelTextSize = sizeArg
End Sub


'--------------------------------------------------------------------------------------------------------------------
Public Sub setHintSmallFont(sizeArg As Int)
	tfe.SmallLabelTextSize = sizeArg
End Sub


'--------------------------------------------------------------------------------------------------------------------
Public Sub setHintColorLarge(colArg As Int)
	tfe.HintColor = colArg
End Sub


'--------------------------------------------------------------------------------------------------------------------
Public Sub setHintColorSamll(colArg As Int)
	tfe.NonFocusedHintColor = colArg
End Sub


'--------------------------------------------------------------------------------------------------------------------
Public Sub setTextFontSizeAndStyle(fontStyle As String, sizeArg As Int)

	Dim tFont As B4XFont

	Select fontStyle
		Case """NORMAL"""
			tFont = xui.CreateFont(Typeface.CreateNew(Typeface.DEFAULT, Typeface.STYLE_NORMAL), sizeArg)
			
		Case """BOLD"""
			tFont = xui.CreateFont(Typeface.CreateNew(Typeface.DEFAULT, Typeface.STYLE_BOLD), sizeArg)
			
		Case """ITALIC"""
			tFont = xui.CreateFont(Typeface.CreateNew(Typeface.DEFAULT, Typeface.STYLE_ITALIC), sizeArg)
			
		Case """BOLD_ITALIC"""
			tFont = xui.CreateFont(Typeface.CreateNew(Typeface.DEFAULT, Typeface.STYLE_BOLD_ITALIC), sizeArg)
	End Select

	tfe.TextField.Font = tFont
End Sub


'--------------------------------------------------------------------------------------------------------------------
Public Sub setTextFontColor(colArg As Int)
	tfe.TextField.Color = colArg
End Sub


'--------------------------------------------------------------------------------------------------------------------
Public Sub setHintColorSmall(colArg As Int)
	tfe.NonFocusedHintColor = colArg
End Sub


'--------------------------------------------------------------------------------------------------------------------
Public Sub GetBase As Panel
	Return mBase
End Sub


'--------------------------------------------------------------------------------------------------------------------
Private Sub tfe_EnterPressed
	
End Sub


'--------------------------------------------------------------------------------------------------------------------
Private Sub tfe_TextChanged (Old As String, New As String)
	Dim item As Object

	Sleep(SleepBeforeSearch)
	
	If 	toolBarBtnClearEvent = False And toolBarBtnUndoEvent = False And toolBarBtnRedoEvent = False And toolBarBtnProperEvent = False Then
		If Old.CompareTo(New) < 0 Then
			'We have added characters
			item = New
			undoList.Add(item)
			undoListIndexLast = undoListIndex
			undoListIndex = undoListIndex + 1
			clearProperVars
		else if Old.CompareTo(New) > 0 Then
			clearProperVars
			'Backspace key
'			Log("Back space Key")
		else if Old.CompareTo(New) == 0 Then
		
		End If
	End If
	
	toolBarBtnClearEvent 	= False
	toolBarBtnUndoEvent 	= False
	toolBarBtnRedoEvent 	= False
	toolBarBtnProperEvent 	= False
	

'	captureTextChange = False
'	Log("Enter Chars - Undo Indx = " & undoListIndex & " UndoLast = " & undoListIndexLast)
'	Log("Old Str = " & Old & "   New Str = " & New)
'	Log("")
End Sub


'--------------------------------------------------------------------------------------------------------------------
Private Sub tfe_FocusChanged (HasFocus As Boolean)
	
End Sub


'--------------------------------------------------------------------------------------------------------------------
Private Sub imgUndo_Click
	'Undo word
	Dim item As Object
	Dim currentText As String
	
	toolBarBtnUndoEvent 	= True
'	captureTextChange 		= False
	
	currentText = tfe.Text

	currentText = Regex.Replace("\s+\w+$", currentText, "")

	item = currentText
	undoList.Add(item)
	undoListIndexLast = undoListIndex
	undoListIndex = undoListIndex + 1

	tfe.Text = currentText
	
'	Log("Enter Chars - Undo Indx = " & undoListIndex & " UndoLast = " & undoListIndexLast)
'	Log("Old Str = " & currentText & "   New Str = " & undoList.Get(undoListIndexLast))
'	Log("")
End Sub


'--------------------------------------------------------------------------------------------------------------------
Private Sub imgRedo_Click
	Dim item As Object
	Dim retrievedText As String
	
	toolBarBtnRedoEvent = True
'	captureTextChange = False

	'Retrieve all of the remaindered text in the undo List and find the first word
	retrievedText = undoList.Get(undoListIndexLast - 1)

	tfe.Text = retrievedText
	item = retrievedText
	undoList.Add(item)
	undoListIndexLast = undoListIndex
	undoListIndex = undoListIndex + 1

'	Log("Undo Word -  Retrieved Text = " & retrievedText & " Undo Indx = " & undoListIndex & " UndoLast = " & undoListIndexLast)
	
End Sub


'--------------------------------------------------------------------------------------------------------------------
Private Sub imgRedo_LongClick

'	captureTextChange = False
End Sub


'--------------------------------------------------------------------------------------------------------------------
Private Sub imgUndo_LongClick
'	captureTextChange = False
	
End Sub


'--------------------------------------------------------------------------------------------------------------------
Private Sub imgProper_Click
	toolBarBtnProperEvent 	= True
'	captureTextChange 		= False
	capsState 				=  capsState + 1 '0 = as entered, 1 = Lower, 2 = Proper, 3 Upper, 4 sqLite, 5 Camel
	setCase(capsState)
	If capsState = 5 Then 
		capsState = -1
	End If
End Sub


'--------------------------------------------------------------------------------------------------------------------
Sub imgProper_LongClick
	tfe.Text = origProperStr
	clearProperVars
End Sub


'--------------------------------------------------------------------------------------------------------------------
Private Sub imgClear_Click
	toolBarBtnClearEvent = True
'	captureTextChange = False
	clearProperVars
	tfe.Text = ""
End Sub


'--------------------------------------------------------------------------------------------------------------------
Private Sub  imgClear_LongClick

	imgClear_Click
End Sub


'--------------------------------------------------------------------------------------------------------------------
public Sub getToolbarHeight As Int
	Return btnPanel.Height
End Sub


'--------------------------------------------------------------------------------------------------------------------
public Sub setToolbarHeight(hArg As Int)
	btnPanel.Height = hArg
End Sub


'--------------------------------------------------------------------------------------------------------------------
public Sub getToolbarWidth As Int
	Return btnPanel.Width
End Sub


'--------------------------------------------------------------------------------------------------------------------
public Sub setToolbarWidth(wArg As Int)
	btnPanel.Width = wArg
End Sub


'--------------------------------------------------------------------------------------------------------------------
private Sub clearProperVars
	origProperStr = ""
	properCycleInit = False
	capsState = 1
End Sub


'--------------------------------------------------------------------------------------------------------------------
private Sub setCase(fcn As Int)
	Dim newStr As String
	Dim pName As properName
	Dim item As Object
	
	pName.Initialize(False, False, False, True, False)

	If properCycleInit 	= False Then
		properCycleInit = True
		origProperStr 	= tfe.Text
	End If
	
		If origProperStr <> "" Then
		newStr = tfe.Text.ToLowerCase
		
		Select fcn
			Case 0
				newStr = origProperStr
				Log(fcn & " Proper - Original")
			
			Case 1
				Log(fcn & " Proper - to Lower")
				
			Case 2
				Log(fcn & " Proper - To Proper")
				newStr = pName.NameToProperCase(origProperStr)
				
			Case 3
				Log(fcn & " Proper - to Upper")
				newStr = origProperStr.ToUpperCase
				
			Case 4
				Log(fcn & " Proper - to sqLite")
				pName.clearExclusions
				newStr = pName.NameToProperCase(origProperStr)
				newStr = convertToSQLiteNames(newStr, ".")
				
				
			Case 5
				Log(fcn & "Proper - to Camel")
				pName.clearExclusions
				newStr = pName.NameToProperCase(origProperStr)
				newStr = convertToCamel(newStr, "")
		End Select
		
		tfe.Text = newStr
		item = newStr
		undoList.Add(item)
		undoListIndexLast = undoListIndex
		undoListIndex = undoListIndex + 1
	End If
	
End Sub


'--------------------------------------------------------------------------------------------------------------------
Public Sub convertToSQLiteNames(name As String, replaceString As String) As String
	Dim regexStr As String
	Dim strTemp As String

	regexStr = $"^\s+|^\p{P}+^|^[^(a-zA-Z)]|[^(a-zA-Z0-9)*]$|[\s]+|[(\p{P}*)]"$
'	regexStr = $"^\s+|^\p{P}+^|^[^(a-zA-Z)]|[^(a-zA-Z0-9)*]$|[\s]+|[(\p{P}*)]"$
	
	strTemp = Regex.Replace(regexStr, name.Trim, "].[")
	strTemp = "[" & strTemp.Trim & "]"
	Return strTemp

	
End Sub


'--------------------------------------------------------------------------------------------------------------------
Public Sub convertToCamel(name As String, replaceString As String) As String
	Dim regexStr As String
	regexStr = $"^\s*|^\p{P}+^[^(a-zA-Z)]|[^(a-zA-Z0-9)]*$|\s|\p{P}+"$
	Return Regex.Replace(regexStr, name.Trim, "")
End Sub


'--------------------------------------------------------------------------------------------------------------------
Public Sub convertToFileNames(name As String) As String
	Dim regexStr As String
	regexStr = $"
	^
	(?!
    (?:
    CON|PRN|AUX|NUL|COM[1-9]|LPT[1-9]
	)	
    ^                               
    (?!
    (?:
    CON|PRN|AUX|NUL|COM[1-9]|LPT[1-9]
    )
    (?:\\.[^.]*)?
    $
    )
    [^<>:\"/\\\\|?*\\x00-\\x1F]*
    [^<>:\"/\\\\|?*\\x00-\\x1F\\ .]
	$
	"$

	Return Regex.Replace(regexStr, name, "_")

End Sub	

'Public static boolean isValidName(String text)
'{
'    Pattern pattern = Pattern.compile(
'        "# Match a valid Windows filename (unspecified file system).          \n" +
'        "^                                # Anchor to start of string.        \n" +
'        "(?!                              # Assert filename is not: CON, PRN, \n" +
'        "  (?:                            # AUX, NUL, COM1, COM2, COM3, COM4, \n" +
'        "    CON|PRN|AUX|NUL|             # COM5, COM6, COM7, COM8, COM9,     \n" +
'        "    COM[1-9]|LPT[1-9]            # LPT1, LPT2, LPT3, LPT4, LPT5,     \n" +
'        "  )                              # LPT6, LPT7, LPT8, and LPT9...     \n" +
'        "  (?:\\.[^.]*)?                  # followed by optional extension    \n" +
'        "  $                              # and end of string                 \n" +
'        ")                                # End negative lookahead assertion. \n" +
'        "[^<>:\"/\\\\|?*\\x00-\\x1F]*     # Zero or more valid filename chars.\n" +
'        "[^<>:\"/\\\\|?*\\x00-\\x1F\\ .]  # Last char is not a space or dot.  \n" +
'        "$                                # Anchor to end of string.            ", 
'        Pattern.CASE_INSENSITIVE | Pattern.UNICODE_CASE | Pattern.COMMENTS);
